/*	ƣjavaȡpropertiesļܽ
 * 	ԴļƣPropertiesFileReadTest.java
 *	Ҫ  㣺
 *		1. ʹgetResourceAsStreamȡpropertiesļ
 *		2. ʹInPutStreamȡpropertiesļ
 *		3. ȡpropertiesļ·д
 *	ʱ䣺2014/4/2
 */
package propertiesFile.read.test;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.text.MessageFormat;
import java.util.Properties;

public class PropertiesFileReadTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			readPropFileByGetResourceAsStream();
			System.out.println("");
			readPropFileByInPutStream();
		} catch (Exception e) {
			e.printStackTrace();// TODO: handle exception
		}
	}

	/**
	 * ʹgetResourceAsStreamȡpropertiesļ
	 */
	static void readPropFileByGetResourceAsStream() {
		/**
		 * ȡsrcconfig.propertiesڵļ 
		 * test1.propertiesλconfig.properties
		 */
		InputStream in1 = PropertiesFileReadTest.class.getClassLoader()
				.getResourceAsStream("config/properties/test1.properties");
		/**
		 * ȡPropertiesFileReadTestλͬһļ 
		 * test2.propertiesPropertiesFileReadTestͬһ
		 */
		InputStream in2 = PropertiesFileReadTest.class
				.getResourceAsStream("test2.properties");
		/**
		 * ȡsrcĿ¼ļļ 
		 * jdbc.propertiesλsrcĿ¼
		 */
		InputStream in3 = PropertiesFileReadTest.class.getClassLoader()
				.getResourceAsStream("jdbc.properties");
		/**
		 * ȡλһsourceļļ 
		 * configһsourceļУconfig.propertiesλconfig sourceļ
		 */
		InputStream in4 = PropertiesFileReadTest.class.getClassLoader()
				.getResourceAsStream("config.properties");

		Properties p = new Properties();
		System.out.println("----ʹgetResourceAsStreamȡpropertiesļ----");
		try {
			System.out
					.println("----------------------------------------------");
			p.load(in1);
			System.out.println("test1.properties:name=" + p.getProperty("name")
					+ ",age=" + p.getProperty("age"));
			System.out
					.println("----------------------------------------------");

			p.load(in2);
			System.out.println("test2.properties:name=" + p.getProperty("name")
					+ ",age=" + p.getProperty("age"));
			System.out
					.println("----------------------------------------------");

			p.load(in3);
			System.out.println("jdbc.properties:");
			System.out.println(String.format("jdbc.driver=%s",
					p.getProperty("jdbc.driver")));// %sjava Stringռλ
			System.out.println(String.format("jdbc.url=%s",
					p.getProperty("jdbc.url")));
			System.out.println(String.format("jdbc.usename=%s",
					p.getProperty("jdbc.usename")));
			System.out.println(String.format("jdbc.password=%s",
					p.getProperty("jdbc.password")));
			System.out
					.println("----------------------------------------------");

			p.load(in4);
			System.out.println("config.properties:");
			System.out.println(MessageFormat.format("dbuser={0}",
					p.getProperty("dbuser")));// {0}һjavaַռλ
			System.out.println(MessageFormat.format("dbpassword={0}",
					p.getProperty("dbpassword")));
			System.out.println(MessageFormat.format("database={0}",
					p.getProperty("database")));
			System.out
					.println("----------------------------------------------");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if (in1 != null) {
				try {
					in1.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in2 != null) {
				try {
					in2.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in3 != null) {
				try {
					in3.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in4 != null) {
				try {
					in4.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	/**
	 * ʹInPutStreamȡpropertiesļ
	 */
	static void readPropFileByInPutStream() {
		InputStream in1 = null;
		InputStream in2 = null;
		InputStream in3 = null;
		InputStream in4 = null;
		System.out.println("----ʹInputStreamȡpropertiesļ----");
		try {
			/**
			 * ȡsrcĿ¼ļļ 
			 * jdbc.propertiesλsrcĿ¼
			 */
			in1 = new BufferedInputStream(new FileInputStream(
					"src/jdbc.properties"));
			/**
			 * ȡsrcconfig.propertiesڵļ 
			 * test1.propertiesλconfig.properties
			 */
			in2 = new BufferedInputStream(new FileInputStream(
					"src/config/properties/test1.properties"));
			/**
			 * ȡPropertiesFileReadTestλͬһļ 
			 * test2.propertiesPropertiesFileReadTestͬһ
			 */
			in3 = new BufferedInputStream(new FileInputStream(
					"src/propertiesFile/read/test/test2.properties"));
			/**
			 * ȡλһsourceļļ 
			 * configһsourceļУconfig.propertiesλconfig sourceļ
			 */
			in4 = new FileInputStream("config/config.properties");

			Properties p = new Properties();
			System.out
					.println("----------------------------------------------");

			p.load(in1);
			System.out.println("jdbc.properties:");
			System.out.println(String.format("jdbc.driver=%s",
					p.getProperty("jdbc.driver")));// %sjava Stringռλ
			System.out.println(String.format("jdbc.url=%s",
					p.getProperty("jdbc.url")));
			System.out.println(String.format("jdbc.usename=%s",
					p.getProperty("jdbc.usename")));
			System.out.println(String.format("jdbc.password=%s",
					p.getProperty("jdbc.password")));
			System.out
					.println("----------------------------------------------");

			p.load(in2);
			System.out.println("test1.properties:name=" + p.getProperty("name")
					+ ",age=" + p.getProperty("age"));
			System.out
					.println("----------------------------------------------");
			p.load(in3);
			System.out.println("test2.properties:name=" + p.getProperty("name")
					+ ",age=" + p.getProperty("age"));
			System.out
					.println("----------------------------------------------");

			p.load(in4);
			System.out.println("config.properties:");
			System.out.println(MessageFormat.format("dbuser={0}",
					p.getProperty("dbuser")));// {0}һjavaַռλ
			System.out.println(MessageFormat.format("dbpassword={0}",
					p.getProperty("dbpassword")));
			System.out.println(MessageFormat.format("database={0}",
					p.getProperty("database")));
			System.out
					.println("----------------------------------------------");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (in1 != null) {
				try {
					in1.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in2 != null) {
				try {
					in2.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in3 != null) {
				try {
					in3.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			if (in4 != null) {
				try {
					in4.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

}
